function [Props,AsgnVals] = pnames(HYBCON)
%PNAMES  All public properties and their assignable values
%
%   [PROPS,ASGNVALS] = PNAMES(HYBCON)  returns the list PROPS of
%   public properties of the object HYBCON (a cell vector), as well as 
%   the assignable values ASGNVALS for these properties (a cell vector
%   of strings).  PROPS contains the true case-sensitive property names.
%
%   See also  GET, SET.

%   (C) 2003 by A. Bemporad


% HYBCON public properties

% Remember to be consistent with HYBCON.M in case of empty @HYBCON objects
Props = {'name';'model';'A';'b';'H';'D';'Y';'f';'Cr';'Cx';... %'Imld';
    'ivar';'uvar';'dvar';'zvar';'epsvar';'nx';'ny';'nu';'nz';'ts';'Q';'horizon';...
        'refsignals';'mipsolver';'pwa';'limits';'hysfile';'norm'};
   
% Also return assignable values if needed
if nargout>1,
   AsgnVals = {'string (MLD model)';...
         'string (Hysdel file name of MLD model)';...
         'nq-by-nvar array';...
         'nq-by-1 array';...
         'nvar-by-nvar array  (only for 2-norm)';...
         'nvar-by-npar array  (only for 2-norm)';...
         'npar-by-npar array  (only for 2-norm)';...
         'nvar-by-1 array     (only for Inf-norm)';...
         'struct';...
         'struct';...
         %'scalar';...
         '1-by-nivar array';...
         '1-by-nu array';...
         '1-by-nd array';...
         '1-by-nz array';...
         'scalar (position of slack var for hard constraints) or string (hard state constraints)';...     
         'scalar (total number of states)';...
         'scalar (total number of outputs)';...
         'scalar (total number of inputs)';...
         'scalar (number of continuous auxiliary vars)';...
         'scalar (sampling time)';...
         'structure (weights)';...
         'scalar (optimal control horizon)';...
         'structure (indices of weighted variables)';...
         'string (MIP solver (MILP or MIQP) )';...
         'PWA object (PWA equivalent of MLD model)';...
         'structure (limits on state and input variables)';
         'string (HYSDEL filename of hybrid model)';...
         'scalar (norm used, either 2 or Inf)';...
     };
end
% end hybcon/pnames.m
