function pwaprops(pwa)
%PWAPROPS  Help on PWA model properties.
%
%  PWAPROPS gives details on the properties of PWA models.
%
%  See also PWA, MLD2PWA.

%	(C) 2003 by A. Bemporad

% PWA properties
DisplayStr={...
    ' Help on properties of PWA models'...
    ' ' ...
    ' xr(t+1)=A(i)xr(t)+B(i)ur(t)+f(i)     x=[xr,xb], u=[ur,ub]' ...
    ' xb(t+1)=LA(i)xr(t)+LB(i)ur(t)+Lf(i)  if Hx(i)x(t)+Hu(i)u(t)<=K(i)' ...
    ' yr(t+1)=C(i)xr(t)+D(i)ur(t)+g(i)     ' ...
    ' yb(t+1)=LC(i)xr(t)+LD(i)ur(t)+Lg(i)  ' ...
    ' ' ...
    '   nr     - number of regions '...
    '   '...
    '   A     - cell array of A(i) matrices'...
    '   B     - cell array of B(i) matrices'...
    '   f     - cell array of f(i) matrices'...
    '   C     - cell array of C(i) matrices'...
    '   D     - cell array of D(i) matrices'...
    '   g     - cell array of g(i) matrices'...
    '   Hx    - cell array of Hx(i) matrices'...
    '   Hu    - cell array of Hu(i) matrices'...
    '   K     - cell array of K(i) matrices'...
    '   '...
    '   LA    - cell array of LA(i) matrices  (Hysdel models: P.LA is always zero)'...
    '   LB    - cell array of LB(i) matrices  (Hysdel models: P.LB is always zero)'...
    '   Lf    - cell array of Lf(i) matrices  '...
    '   LC    - cell array of LC(i) matrices  (Hysdel models: P.LC is always zero)'...
    '   LD    - cell array of LD(i) matrices  (Hysdel models: P.LD is always zero)'...
    '   Lg    - cell array of Lg(i) matrices  '...
    '   '...
    '   logic - cell array of combinations of (xl,ul,delta) variables'...
    '   '...
    '   nx    - state dimension'...
    '   nxr   - continuous state dimension'...
    '   nxb   - logic state dimension'...
    '   nu    - input dimension'...
    '   nur   - continuous input dimension'...
    '   nub   - logic input dimension'...
    '   '...
    '   name  - Name of HYSDEL file which generated the MLD model (if any)'...
    '   ts    - Sampling time'...
    '   '...   
};

disp('   ')
disp(char(DisplayStr))

